package com.xydl.cac.iec104;

import lombok.extern.slf4j.Slf4j;
import org.openmuc.j60870.*;
import org.openmuc.j60870.ie.IeQualifierOfInterrogation;

import java.io.IOException;
import java.net.InetAddress;

@Slf4j
public class Iec104Client implements ConnectionEventListener {
    public String ip;
    public Integer port;
    Connection connection;

    public void connect(String _ip, Integer _port) throws Exception {
        ip = _ip;
        port = _port;
        InetAddress address = InetAddress.getByName(ip);
        ClientConnectionBuilder clientConnectionBuilder = new ClientConnectionBuilder(address)
                .setMessageFragmentTimeout(5_000)
                .setConnectionTimeout(20_000)
                .setPort(port)
                .setConnectionEventListener(this);
        connection = clientConnectionBuilder.build();
    }

    public void disconnect() {
        if (connection != null) {
            connection.close();
        }
    }

    public void interrogation() throws Exception {
        connection.interrogation(1, CauseOfTransmission.ACTIVATION,
                new IeQualifierOfInterrogation(20));
    }

    @Override
    public void newASdu(Connection connection, ASdu aSdu) {
        log.debug("Got new ASdu:" + aSdu.toString());
    }

    @Override
    public void connectionClosed(Connection connection, IOException e) {

    }

    @Override
    public void dataTransferStateChanged(Connection connection, boolean b) {

    }
}
